//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007, 2008 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

int conf_rehash = 0;
int cwarning(const unsigned char* content,int line) {
	unsigned char mystringle_replace[700];
	if (conf_rehash == 0) {
		if (line >= 0) {
			printf("Warning while parsing config file: Error in line %d: %s\n",line,content);
		}else{
			printf("Warning while loading config/additional files: %s\n",content);
		}
	}else{
		strcpy(mystringle_replace,"\0");
		if (line >= 0) {
			sprintf(&mystringle_replace[0],"[CONFIG] Warning while parsing config file: Error in line %d: %s\0",line,content);
		}else{
			sprintf(&mystringle_replace[0],"[CONFIG] Warning while loading config/additional files: %s\0",content);
		}
	}
	return;
}
int cerr(const unsigned char* content,int line) {
	unsigned char mystringle_replace[700];
	if (conf_rehash == 0) {
		if (line >= 0) {
			printf("%s    > Parsing config failed: Error in line %d:\n%s        %s\n",startupprefixsub,line,startupprefixsub,content);
		}else{
			printf("%s    > Error while loading config/additional files:\n%s        %s\n",startupprefixsub,startupprefixsub,content);
		}
	}else{
		strcpy(mystringle_replace,"\0");
		if (line >= 0) {
			sprintf(&mystringle_replace[0],"[CONFIG] Parsing config failed: Error in line %d: %s\0",line,content);
		}else{
			sprintf(&mystringle_replace[0],"[CONFIG] Error while loading config/additional files: %s\0",content);
		}
	}
	return;
}
unsigned char vfileerror[500];
void tellfileerror() {
	if (errno == EPERM || errno == EACCES) {
		strcpy(vfileerror,"no permission");return;
	}
	if (errno == ENOENT || errno == EFAULT || errno == ENODEV) {
		strcpy(vfileerror,"file not found!");return;
	}
	if (errno == EISDIR) {
		strcpy(vfileerror,"target is a directory");return;
	}
	if (errno == EBUSY) {
		strcpy(vfileerror,"device is busy");return;
	}
	if (errno == ETXTBSY) {
		strcpy(vfileerror,"blocked because of other read/write operation (likely of another program)");return;
	}
	if (errno == EMFILE || errno == ENFILE) {
		strcpy(vfileerror,"too many files are already opened");return;
	}
	strcpy(vfileerror,"unknown error");return;
}
int expectopeningbracket = 0;
int config_testforblock(unsigned char* line,unsigned char* currblock,const unsigned char* blockname, int linenumber) {
	if (strcasecmp(currblock,"") != 0) {return -1;}
	unsigned char withspace[50];
	strncpy(withspace,blockname,48);withspace[48] = 0;
	strcat(withspace," ");
	if (strcasecmp(line,blockname) == 0 || strstw(line,withspace) == true) {
		if (strstw(line,withspace) == true) {
			cut(line,strlen(withspace));
			trimleft(line);
			if (strcasecmp(line,"{") != 0) {
				cerr("Expected '{'",linenumber);
				return -2;
			}else{
				strcpy(currblock,blockname);
				strlwr(currblock);
				expectopeningbracket = 0;
				return 0;
			}
		}else{
			strcpy(currblock,blockname);
			strlwr(currblock);
			expectopeningbracket = 1;
			return 0;
		}
	}
	return -1;
}
int readconfig(int IsRehash) {
	if (resetoptions == 0) {resetoptions = 1;memset(&newoptions,0,sizeof(newoptions));memset(&currentoptions,0,sizeof(currentoptions));}
	conf_rehash = IsRehash;
	if (IsRehash == 0) {
		printf("%s Reading config file...\n",startupprefix);
	}
	FILE *r;
	int k;
	int linenumber;
	char line[300];
	char templine[300];
	char linecommand[300];
	unsigned char error1[300];
	unsigned char error2[300];
	unsigned char error3[300];
	unsigned char error4[300];
	unsigned char currblock[50] = "";
	r = fopen("weircdconf.cfg","r");
	if (r <= 0) {
		tellfileerror();
		strcpy(error1,"Not able to open ./weircdconf.cfg: ");strcat(error1,vfileerror);
		r = fopen("/usr/share/weircdconf.cfg","r");
		if (r <= 0) {
			tellfileerror();
			strcpy(error2,"Not able to open /usr/share/weircdconf.cfg: ");strcat(error1,vfileerror);
			r = fopen("/etc/weircdconf.cfg","r");
			if (r <= 0) {
				tellfileerror();
				strcpy(error3,"Not able to open /etc/weircdconf.cfg: ");strcat(error1,vfileerror);
				r = fopen("/usr/weircdconf.cfg","r");
				if (r <= 0) {
					tellfileerror();
					strcpy(error4,"Not able to open /usr/weircdconf.cfg: ");strcat(error1,vfileerror);
					cerr(error1,-1);
					cerr(error2,-1);
					cerr(error3,-1);
					cerr(error4,-1);
					return -1;
				}
			}
		}
	}
	if (newoptions.serverdomain != NULL) {free(newoptions.serverdomain);newoptions.serverdomain = NULL;}
	if (newoptions.networkname != NULL) {free(newoptions.networkname);newoptions.networkname = NULL;}
	if (newoptions.bindip != NULL) {free(newoptions.bindip);newoptions.bindip = NULL;}
	newoptions.bindport = -1;
	newoptions.vmaxchansperuser = -1;
	newoptions.hostcloaking_activated = -1;
	newoptions.services_activated = -1;
	linenumber = 0;
	while (fgets(line, 300, r) != NULL) {
		linenumber += 1;
		allesvorzeichen(35,line,line);//comments with # (asc 35)
		strcpy(line,replacechar(line,13,0));
		strcpy(line,replacechar(line,10,0));
		strcpy(line,replacechar(line,20,0));
		trimleft(line);trimright(line);
		if (strcasecmp(currblock,"") == 0) {
			trimleft(line);trimright(line);
			if (config_testforblock(line,currblock,"server",linenumber) < -2) {fclose(r);return -1;}
			if (config_testforblock(line,currblock,"services",linenumber) < -2) {fclose(r);return -1;}
			if (config_testforblock(line,currblock,"ircops",linenumber) < -2) {fclose(r);return -1;}
			if (strcasecmp(currblock,"") == 0) {
				if (strlen(line) > 0) {
					cutonfirstspace(line);
					strcpy(linecommand,"'");
					strncat(linecommand,line,59);linecommand[59] = 0;
					strcat(linecommand,"' is an unknown block name");
					cerr(linecommand,linenumber);return -1;
				}
			}
		}else{
			if (expectopeningbracket == 1) {
				if (line[0] == '{') {
					cut(line,1);
					expectopeningbracket = 0;
				}else{
					cerr("Expected '{'",linenumber);
					return -1;
				}
			}
			trimleft(line);
			if (strlen(line) > 0) {
				if (strcasecmp(line,"}") == 0) {
					strcpy(currblock,"");continue;
				}
				allesvorzeichen(61,linecommand,line);
				allesnachzeichen(61,line,line);
				trimleft(line);
				cutonfirstspace(line);cutonfirstspace(linecommand);
				if (strcasecmp(line,"") != 0 || strcasecmp(linecommand,"") != 0) {
					if (strcasecmp(line,"") == 0) {
						strcpy(line,"Syntax error - no argument for config option '");
						strncat(line,linecommand,109);
						line[109] = 0;
						strcat(line,"' in block '");
						strcat(line,currblock);
						strcat(line,"'");
						cerr(line,linenumber);fclose(r);return -1;
					}
					if (strcasecmp(linecommand,"") == 0) {
						cerr("Syntax error - no option",linenumber);fclose(r);return -1;
					}
				}
				if (strcasecmp(currblock,"server") == 0) {
					if (strcasecmp(linecommand,"name") == 0) {
						if (strlen(line) > 50) {
							cerr("Invalid value - value 'name' in block 'server' is too long (max 50 chars)!",linenumber);fclose(r);return -1;
						}
						newoptions.serverdomain = malloc(strlen(line) + 1);
						if (newoptions.serverdomain != NULL) {
							strcpy(newoptions.serverdomain,line);
						}
						continue;
					}
					if (strcasecmp(linecommand,"bindip") == 0) {
						newoptions.bindip = malloc(strlen(line) + 1);
						if (newoptions.bindip != NULL) {
							strcpy(newoptions.bindip,line);
						}
						continue;
					}
					if (strcasecmp(linecommand,"network") == 0) {
						if (strlen(line) > 50) {
							cerr("Invalid value - value 'network' in block 'server' is too long (max 50 chars)!",linenumber);fclose(r);return -1;
						}
						newoptions.networkname = malloc(strlen(line) + 1);
						if (newoptions.networkname != NULL) {
							strcpy(newoptions.networkname,line);
						}
						continue;
					}
					if (strcasecmp(linecommand,"hostcloaking") == 0) {
						if (strcasecmp(line,"true") != 0 && strcasecmp(line,"false") != 0) {
							cerr("Invalid value - 'true' or 'false' expected",linenumber);fclose(r);return -1;
						}
						if (strcasecmp(line,"true") == 0) {
							newoptions.hostcloaking_activated = 1;
						}else{
							newoptions.hostcloaking_activated = 0;
						}
						continue;
					}
					if (strcasecmp(linecommand,"port") == 0) {
						if (atoi(line) < 1 || atoi(line) > 99999) {
							cerr("Invalid value - number between 1 and 99999 expected",linenumber);fclose(r);return -1;
						}
						newoptions.bindport = atoi(line);
						continue;
					}
					if (strcasecmp(linecommand,"maxchansperuser") == 0) {
						if (atoi(line) < 1 || atoi(line) > COMPILEOPTION_MAXCHANSPERUSER) {
							sprintf(&line[0],"Invalid value - number between 1 and %d expected",COMPILEOPTION_MAXCHANSPERUSER);
							cerr(line,linenumber);fclose(r);return -1;
						}
						newoptions.vmaxchansperuser = atoi(line);
						continue;
					}
				}
				if (strcasecmp(currblock,"services") == 0) {
					if (strcasecmp(linecommand,"enabled") == 0) {
						if (strcasecmp(line,"true") != 0 && strcasecmp(line,"false") != 0) {
							cerr("Invalid value - 'true' or 'false' expected",linenumber);fclose(r);return -1;
						}
						if (strcasecmp(line,"true") == 0) {
							newoptions.services_activated = 1;
						}else{
							newoptions.services_activated = 0;
						}
						continue;
					}
				}
				strcpy(line,"Unknown config option '");
				strncat(line,linecommand,109);line[109] = 0;
				strcat(line,"' in block '");strcat(line,currblock);strcat(line,"'");
				cerr(line,linenumber);
				fclose(r);
				return -1;
			}
		}
	}
	fclose(r);
	if (newoptions.serverdomain == NULL) {
		cerr("CONFIG ERROR: Server block: name option is missing.",-1);return -1;
	}
	if (newoptions.networkname == NULL) {
		cerr("CONFIG ERROR: Server block: network option is missing.",-1);return -1;
	}
	if (newoptions.bindip == NULL) {
		cerr("CONFIG ERROR: Server block: BindIP option is missing.",-1);return -1;
	}
	if (newoptions.bindport <= 0) {
		cerr("CONFIG ERROR: Server block: port is missing.",-1);return -1;
	}
	if (newoptions.vmaxchansperuser <= 0) {
		cerr("CONFIG ERROR: Server block: MaxChansPerUser is missing.",-1);return -1;
	}
	if (newoptions.hostcloaking_activated < 0) {
		cerr("CONFIG ERROR: Server block: HostCloaking is missing.",-1);return -1;
	}
	if (newoptions.services_activated < 0) {
		cerr("CONFIG ERROR: Services block: enabled is missing.",-1);return -1;
	}
	if (currentoptions.serverdomain != NULL) {free(currentoptions.serverdomain);}currentoptions.serverdomain = newoptions.serverdomain;
	if (currentoptions.networkname != NULL) {free(currentoptions.networkname);}currentoptions.networkname = newoptions.networkname;
	if (currentoptions.bindip != NULL) {free(currentoptions.bindip);}currentoptions.bindip = newoptions.bindip;
	currentoptions.bindport = newoptions.bindport;
	currentoptions.vmaxchansperuser = newoptions.vmaxchansperuser;
	currentoptions.hostcloaking_activated = newoptions.hostcloaking_activated;
	currentoptions.services_activated = newoptions.services_activated;
	if (IsRehash == 0) {
		printf("%s    > Done\n",startupprefixsub);
	}
	return 0;
}
