//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007, 2008 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

void setSocketNonblocking(int socket) {
	int save_fd;
	save_fd = fcntl(socket, F_GETFL);
	save_fd |= O_NONBLOCK;
	fcntl(socket, F_SETFL, save_fd);
}
int mastersocket, addrlen;
struct sockaddr_in masteraddress;
int socketsStartup(char* vbind,int port) {
	addrlen = sizeof (struct sockaddr_in);
	const int lclyes = 1;
	memset(&masteraddress, 0, sizeof(struct sockaddr_in));
	printf("%s Initialising internet connection...\n",startupprefix);
	if ((mastersocket = socket(AF_INET, SOCK_STREAM, 0)) > 0) {
		printf ("%s    > Socket opened\n",startupprefixsub);
	}else{
		printf("%s    > Was not able to get a socket!\n",startupprefixsub);
		return -1;
	}
	masteraddress.sin_family = AF_INET;
	if (!inet_aton(vbind, &masteraddress.sin_addr)) {
		printf("%s    > Setting socket address to %s failed.\n",startupprefixsub,vbind);
		return -1;
	}
	masteraddress.sin_port = htons (port);
	setsockopt(mastersocket, SOL_SOCKET,SO_REUSEADDR, &lclyes, sizeof(int));
	if (bind(mastersocket,(struct sockaddr *) &masteraddress,sizeof (masteraddress)) == 0) {
		printf("%s    > Binding to %s:%d successful.\n",startupprefixsub,vbind,port);
	}else{
		printf("%s    > Binding to %s:%d failed! Terminating.\n",startupprefixsub,vbind,port);return;
	}
	listen (mastersocket, 6667);
	setSocketNonblocking(mastersocket);
}
void checkNewClients() {
	struct sockaddr_in address;
	int new_socket,r;
	new_socket = accept(mastersocket,(struct sockaddr *) &masteraddress,&addrlen);
	if (new_socket > 0) {
		setSocketNonblocking(new_socket);
		r = userAdd(new_socket);
		if (r >= 0) {
			sendStartup(r);
			strncpy(userpointers[r]->ip,inet_ntoa (masteraddress.sin_addr),16);
			userpointers[r]->ip[16] = 0;
			strcpy(userpointers[r]->host,userpointers[r]->ip);
		}
	}
}
void ircproceed(int userid) {
	unsigned char lclstring[600];
	unsigned char lclstring2[600];
	strncpy(lclstring,userpointers[userid]->recvbuffer,599);
	lclstring[599] = 0;
	int r = 0;
	r = charpos(userpointers[userid]->recvbuffer,'\n');
	if (r >= 0) {
		cut(userpointers[userid]->recvbuffer,r + 1);
		if (r <= 599) {
			lclstring[r] = 0;
		}
	}
	userpointers[userid]->floodprotect.floodpoints += 1;
	userpointers[userid]->floodprotect.sendlines += 1;
	trimleft(lclstring);
	allesnachzeichen(32,lclstring2,lclstring);
	allesvorzeichen(32,lclstring,lclstring);
	userCMD(userid,lclstring,lclstring2);
}
void receiveOnSocket(int userid) {
	unsigned char lclbuffa[USER_RECVBUFFERSIZE + 1];
	//printf("recv %d\n",userpointers[userid]->socket);
	int z;
	if (strlen(userpointers[userid]->recvbuffer) < USER_RECVBUFFERSIZE - 1) {
		int k = strlen(userpointers[userid]->recvbuffer);
		errno = 0;
		z = recv(uSocket(userid),lclbuffa,USER_RECVBUFFERSIZE - (k+1),0);
		if (z > 0) {
			//printf("RECEIVED SOMETHING!\n");
			lclbuffa[z] = 0;
			strcat(userpointers[userid]->recvbuffer,lclbuffa);
			k = k+z;
			z = 0;
			while (z < k) {
				if (userpointers[userid]->recvbuffer[z] == 0) {userpointers[userid]->recvbuffer[z] = 32;}
				z += 1;
			}
			z = 0;
			while (z < k-1) {
				if (userpointers[userid]->recvbuffer[z] == '\r') {
					userpointers[userid]->recvbuffer[z] = '\n';
					if (userpointers[userid]->recvbuffer[z+1] == '\n') {
						userpointers[userid]->recvbuffer[z+1] = 32;
					}
				}
				z += 1;
			}
			while (charpos(userpointers[userid]->recvbuffer,'\n') >= 0) {
				ircproceed(userid);
			}
			return;
		}else{
			if ((errno != EWOULDBLOCK && errno != EINTR && errno != EAGAIN && errno != ENOBUFS) || z == 0) {
				//printf("RECV:QUIT %d %d %d\n",USER_RECVBUFFERSIZE - (k+1),z,errno);
				userQuit(userid,USERQUIT_EOF);
			}
		}
	}
}
int sendOnSocket(int userid,const unsigned char* buffer,int buffsize) {
	errno = 0;
	int retval = send(uSocket(userid),buffer,buffsize,MSG_NOSIGNAL);
	if (retval > 0) {
		return retval;
	}else{
		if ((errno != EWOULDBLOCK && errno != EINTR && errno != ENOBUFS) || retval == 0) {
			userQuit(userid,USERQUIT_EOF);
			return -1;
		}else{
			return 0;
		}
	}
}
void sendMeIfYouCan(int userid) {
	int k;
	if (userpointers[userid]->sendbuffer[0] != NULL) {
		k = sendOnSocket(userid,userpointers[userid]->sendbuffer[0],strlen(userpointers[userid]->sendbuffer[0]));
		if (k == strlen(userpointers[userid]->sendbuffer[0])) {
			scrollSendBuffer(userid);
		}else{
			if (k < 0) {return;}//something went wrong
			if (k > 0) {cut(userpointers[userid]->sendbuffer[0],k);}
		}
	}
}
void sendAll() {
	int i = 0;
	while (i < COMPILEOPTION_MAXUSERS) {
		if (userpointers[i] != NULL) {
			if (userpointers[i]->pleaseremove == false) {
				sendMeIfYouCan(i);
			}
		}
		i += 1;
	}
}
void receiveAll() {
	int i = 0;
	while (i < COMPILEOPTION_MAXUSERS) {
		if (userpointers[i] != NULL) {
			if (userpointers[i]->pleaseremove == false) {
				receiveOnSocket(i);
			}
		}
		i += 1;
	}
}
