//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007, 2008 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#define USERQUIT_SIGPIPE 1
#define USERQUIT_QUIT 2
#define USERQUIT_EOF 3
#define USERQUIT_TIMEOUT 4
#define USERQUIT_ERROR 5
#define USER_MAXSENDBUFFERS 20
#define USER_RECVBUFFERSIZE 1024
struct weircd_user_floodprotect {
	int floodpoints; //one gets substracted every second and some added for various actions
	int sendlines; //one point added for every sent line and two substracted every second
};
struct weircd_user {
	unsigned char ip[17];
	unsigned char* sendbuffer[USER_MAXSENDBUFFERS];
	unsigned char recvbuffer[USER_RECVBUFFERSIZE];
	unsigned char host[COMPILEOPTION_MAXHOSTLEN];
	bool authed;//001 message passed
	long authpongvalue;
	int pleaseremove;
	long pleaseremove_time;
	bool sendbeforeremove;
	long logintime;
	int socket;
	struct weircd_user_floodprotect floodprotect;
	unsigned char nickname[COMPILEOPTION_MAXNICKLEN + 1];
	unsigned char suserid[COMPILEOPTION_MAXUSERIDLEN + 1];
	unsigned char realname[COMPILEOPTION_MAXREALNAMELEN + 1];
};

struct weircd_user* userpointers[COMPILEOPTION_MAXUSERS];
int userslotcount = 0;

void weircdUserInit() {
	int r = 0;
	while (r < COMPILEOPTION_MAXUSERS) {
		userpointers[r] = NULL;
		r += 1;
	}
}
int userAdd(int socket) {
	int r = 0;
	while (r < COMPILEOPTION_MAXUSERS) {
		if (userpointers[r] == NULL) {
			userpointers[r] = malloc(sizeof(struct weircd_user));
			memset(userpointers[r], 0, sizeof(struct weircd_user));
			userpointers[r]->socket = socket;
			userpointers[r]->authed = false;
			userpointers[r]->sendbeforeremove = false;
			return r;
		}
		r += 1;
	}
	close(socket);//adding failed!
	return -1;
}
unsigned char* un(int uid) {
	if (userpointers[uid] != NULL) {
		return userpointers[uid]->nickname;
	}else{
		return NULL;
	}
}
int ubn(const unsigned char* nickname) {//UserByName()
	int r = 0;
	while (r < COMPILEOPTION_MAXUSERS) {
		if (userpointers[r] != NULL) {
			if (strcasecmp(userpointers[r]->nickname,nickname) == 0 && userpointers[r]->pleaseremove == false) {
				return r;
			}
		}
		r += 1;
	}
	return -1;
}
int uSocket(int uid) {
	return userpointers[uid]->socket;
}
void userQuit(int uid, int reason) {
	if (reason != USERQUIT_ERROR) {
		userpointers[uid]->pleaseremove = true;
		userpointers[uid]->sendbeforeremove = false;
	}else{
		if (userpointers[uid]->pleaseremove == true) {return;}
		userpointers[uid]->pleaseremove = true;
		userpointers[uid]->pleaseremove_time = time(NULL);
		userpointers[uid]->sendbeforeremove = true;
	}
}
void clearusers() {
	int r = 0;
	while (r < COMPILEOPTION_MAXUSERS) {
		if (userpointers[r] != NULL) {
			if (userpointers[r]->pleaseremove == true) {
				if (userpointers[r]->sendbeforeremove == false || userpointers[r]->pleaseremove_time + 2 < time(NULL)) {
					close(userpointers[r]->socket);
					userpointers[r] = NULL;
				}
			}
		}
		r += 1;
	}
}
